// InDesign Fixups by Dave Merchant  - Creative Commons Share-alike license
// version 02, November 2010
// http://www.uvsar.com/go/indesignfixups



// -- create new submenu for the Acrobat 8/9 or X menus -- //

var menuParent = (app.viewerVersion<10)? "DocumentProcessing":"Edit";

app.addSubMenu({ cName:"InDesignFixups", cUser:"InDesign Fixups", cParent:menuParent, nPos:((app.viewerVersion<10)? 0:7) });

app.addMenuItem({ cName:"IDFUpromote", cUser:"Promote Layers", cParent:"InDesignFixups",
		  cExec:"promoteOCG_handler(event.target);",
		  cEnable:"event.rc = (event.target != null);", nPos:0 });

app.addMenuItem({ cName:"IDFUremGAG", cUser:"Unlist 'Guides and Grids'", cParent:"InDesignFixups",
		  cExec:"removeGAG(event.target);",
		  cEnable:"event.rc = (event.target != null);", nPos:1 });

app.addMenuItem({ cName:"IDFUhelp", cUser:"Online Help", cParent:"InDesignFixups", 
		  cExec:"app.launchURL('www.uvsar.com/go/indesignfixups');", nPos:2 });


function promoteOCG_handler(oDoc) {

  var ocgOrder = oDoc.getOCGOrder();
  var hasNest = false;

  if (ocgOrder==null) {
    app.alert( "No layers in current file", 0, 0, "Cannot proceed");
  } else {
    for (var i=0; i<ocgOrder.length; i++) {
       if ((typeof(ocgOrder[i]) == "object") && (ocgOrder[i].length > 0)) hasNest = true;
    }
    if (hasNest)  {
      promoteOCGs(oDoc,ocgOrder);
    } else app.alert( "No nested layers in current file", 0, 0, "Cannot proceed");
  }
}
  


function promoteOCGs(oDoc,ocgOrder) {

  // Removes the top-level OCG nest structure from a PDF, promoting all sub-OCGs to the top level.
  // Used to remove the nesting created when a PDF is exported from InDesign with "Create Acrobat Layers" checked.


  var oChk = { cMsg:"Unlist the 'Guides and Grids' layer?", bInitialValue:true, bAfterValue:false};

  var cMesg = "This action will ungroup all nested layers. IT CANNOT BE UNDONE.\n\nDo you want to continue?";
  var nRtn = app.alert({ cMsg:cMesg, nIcon:2, nType:2, cTitle:"Promote nested layers", oCheckbox:oChk});
  if (nRtn == 4) {

    var newOrder = new Array();

    for (var i=0; i<ocgOrder.length; i++) {

     var oType = typeof(ocgOrder[i]);
     var oLeng = ocgOrder[i].length
     if ((oType == "object") && (oLeng > 0)) {     	// it's a nest, do the promotions

    	for (var j=0; j<oLeng; j++) {
       	   if ((typeof(ocgOrder[i][j]) == "object") && 
              (!oChk.bAfterValue || (ocgOrder[i][j].name != "Guides and Grids"))) newOrder.push(ocgOrder[i][j]);
    	}
  
     } else if (!oChk.bAfterValue || (ocgOrder[i].name != "Guides and Grids")) newOrder.push(ocgOrder[i]);
    }
    oDoc.setOCGOrder( newOrder );
  }
}



function removeGAG(oDoc) {

  // Removes the listing for (sub)OCG named "Guides and Grids".
  // Does NOT delete the layer, simply hides it from the sidebar display.


  var cMesg = "This action will unlist the 'Guides and Grids' layer from the sidebar but will NOT delete the ";
  cMesg += "layer itself. IT CANNOT BE UNDONE.\n\nDo you want to continue?";
  var nRtn = app.alert(cMesg, 2, 2, "Unlist 'Guides and Grids'");
  if (nRtn == 4) {

    var ocgOrder = oDoc.getOCGOrder();
    var newOrder = new Array();

    for (var i=0; i<ocgOrder.length; i++) {

     var oType = typeof(ocgOrder[i]);
     var oLeng = ocgOrder[i].length
     if ((oType == "object") && (oLeng > 0)) {     	// it's a nest

        var subObj = new Array();
    	for (var j=0; j<oLeng; j++) {
       	   if ((typeof(ocgOrder[i][j]) == "string") || (ocgOrder[i][j].name != "Guides and Grids")) subObj.push(ocgOrder[i][j]);
    	}
        newOrder.push(subObj);

     } else if (ocgOrder[i].name != "Guides and Grids") newOrder.push(ocgOrder[i]);
    }
    oDoc.setOCGOrder( newOrder );
  }
}
